// ============================================================================
// ==                                                                        ==
// == AMDiS - Adaptive multidimensional simulations                          ==
// ==                                                                        ==
// ============================================================================
// ==                                                                        ==
// ==  TU Dresden                                                            ==
// ==                                                                        ==
// ==  Institut fr Wissenschaftliches Rechnen                               ==
// ==  Zellescher Weg 12-14                                                  ==
// ==  01069 Dresden                                                         ==
// ==  germany                                                               ==
// ==                                                                        ==
// ============================================================================
// ==                                                                        ==
// ==  https://gforge.zih.tu-dresden.de/projects/amdis/                      ==
// ==                                                                        ==
// ============================================================================

/** \file GNUPlotWriter.h */

#ifndef AMDIS_GNUPLOTWRITER_H
#define AMDIS_GNUPLOTWRITER_H

#include <vector>
#include <string>
#include "FileWriter.h"
#include "AMDiS_fwd.h"

namespace AMDiS {

  ///
  class GNUPlotWriter : public FileWriterInterface
  {
  public:
    ///
    GNUPlotWriter(std::string filename,
		  FiniteElemSpace *feSpace,
		  std::vector<DOFVector<double>*> &dofVectors);

    ///
    virtual ~GNUPlotWriter() {}

    ///
    virtual void writeFiles(AdaptInfo *adaptInfo, bool force);

  protected:
    /// Contains the mesh
    FiniteElemSpace *feSpace_;

    /// vector of dof vectors to write
    std::vector<DOFVector<double>*> dofVectors_;

    /// file name
    std::string filename_;
  };

}

#endif // AMDIS_VALUEWRITER_H
